
#include <cpctelera.h>
#include "hero.h"
#include "enemy.h"
#include "fjuego.h"
#include "map1.h"
#include "tiles.h"
#include "menu.h"
#include "vida.h"
#include "fondo.h"
//#include "cancion.h"
//#include <stdlib.h>
//#include <stdio.h>

#define SI 1
#define NO 0

#define ANCHOPROTA   (16/2) //14
#define ALTOPROTA    26

#define ORIGEN_MAPA_Y 68 //Se situa el mapa en la linea 68
#define ORIGEN_MAPA cpctm_screenPtr(CPCT_VMEM_START, 0, ORIGEN_MAPA_Y)

u8 random_number;

typedef struct {
   u8  mira;
   u8* sprite;
} TFrame;

typedef struct{
	u8  x, y;
	u8  px, py;
	u8 mover;
	u8 estado;
	TFrame* frame;
	u8 nframe;
	u8 mira;
	u8 salto;
	u8 vida;
} TProta;

TProta prota;

typedef struct{
	u8  x, y;
	u8  px, py;
	u8 mover;
	u8 estado;
	TFrame* frame;
	u8 nframeRetraso;
	u8 nframe;
	u8 mira;
	u8 salto;
	u8 vida;
} TEnemigo;

TEnemigo enemigo;

// Mirando hacia
enum {
      M_derecha   = 0
   ,  M_izquierda
} EMirar;

// Eventos del personaje
enum {
      EV_detenerse = 0
   ,  EV_moverse
   ,  EV_saltar
   ,  EV_numEventos
} EEventos;

// Estados del personaje
enum {
      ST_quieto  = 0
   ,  ST_andando
   ,  ST_prepSalto
   ,  ST_saltando
   ,  ST_cayendo
   ,  ST_aterrizando
   ,  ST_numEstados
   ,  ST_punyetazo
   ,  ST_agachado
   ,  ST_patada
   ,  ST_defensa
   ,  ST_patadaAerea
   ,  ST_defensa_agachado
   ,  ST_punyetazo_agachado
} EEstados;


u8* mapa; //el mapa es un puntero

#define VIDA 100
#define ANCHO_PANTALLA 80
#define LIMITE_DERECHO ANCHO_PANTALLA - G_HERO_00_W

// Estado de Sprites
#define HERO_FRAMES  14 //16
const TFrame g_frames[HERO_FRAMES] = {
      { M_derecha, g_hero_00 }   ,  { M_derecha, g_hero_01 }
   ,  { M_derecha, g_hero_02 }   ,  { M_derecha, g_hero_03 }
   ,  { M_derecha, g_hero_04 }   ,  { M_derecha, g_hero_05 }
   ,  { M_derecha, g_hero_06 }   ,  { M_derecha, g_hero_07 }
   ,  { M_derecha, g_hero_08 }   ,  { M_derecha, g_hero_09 }
   ,  { M_derecha, g_hero_10 }   ,  { M_derecha, g_hero_11 }
   ,  { M_derecha, g_hero_12 }   ,  { M_derecha, g_hero_13 }
  // ,  { M_derecha, g_hero_14 }   ,  { M_derecha, g_hero_15 }
}; //Todos los sprites dentro de un array

#define ENEMY_FRAMES  14 //16
const TFrame e_frames[ENEMY_FRAMES] = {
      { M_derecha, e_enemy_00 }   ,  { M_derecha, e_enemy_01 }
   ,  { M_derecha, e_enemy_02 }   ,  { M_derecha, e_enemy_03 }
   ,  { M_derecha, e_enemy_04 }   ,  { M_derecha, e_enemy_05 }
   ,  { M_derecha, e_enemy_06 }   ,  { M_derecha, e_enemy_07 }
   ,  { M_derecha, e_enemy_08 }   ,  { M_derecha, e_enemy_09 }
   ,  { M_derecha, e_enemy_10 }   ,  { M_derecha, e_enemy_11 }
   ,  { M_derecha, e_enemy_12 }   ,  { M_derecha, e_enemy_13 }
  // ,  { M_derecha, e_enemy_14 }   ,  { M_derecha, e_enemy_15 }
}; //Todos los sprites dentro de un array

//Animaciones
#define ANIM_PAUSA      6 //A mayor numero, mayor tiempo tardan las animaciones
#define ANDAR_FRAMES    5
#define SALTAR_FRAMES   1
#define PUNYETAZO_FRAMES 2
#define AGACHAR_FRAMES 2
#define PATADA_FRAMES 2
#define DEFENSA_FRAMES 2
#define DEFENSA_AGACHADO_FRAMES 2
#define PATADAAEREA_FRAMES 2
#define PUNYETAZO_AGACHADO_FRAMES 2


TFrame* const anim_andar[ANDAR_FRAMES] = { 
   &g_frames[1], &g_frames[2], &g_frames[3], &g_frames[4], &g_frames[5]
}; //Array de sprites de andar
TFrame* const anim_andar_enemigo[ANDAR_FRAMES] = { 
   &e_frames[1], &e_frames[2], &e_frames[3], &e_frames[4], &e_frames[5]
}; //Array de sprites de andar
TFrame* const anim_punyetazo[PUNYETAZO_FRAMES] = { 
   &g_frames[9], &g_frames[0]
};
TFrame* const anim_punyetazo_enemigo[PUNYETAZO_FRAMES] = { 
   &e_frames[9], &e_frames[0]
};
TFrame* const anim_patada[PATADA_FRAMES] = { 
   &g_frames[10], &g_frames[0]
};
TFrame* const anim_patada_enemigo[PATADA_FRAMES] = { 
   &e_frames[10], &e_frames[0]
};
TFrame* const anim_agachado[AGACHAR_FRAMES] = { 
   &g_frames[6]
};
TFrame* const anim_agachado_enemigo[AGACHAR_FRAMES] = { 
   &e_frames[6], &e_frames[0]
};
TFrame* const anim_defensa[DEFENSA_FRAMES] = { 
   &g_frames[11]
};
TFrame* const anim_defensa_enemigo[DEFENSA_FRAMES] = { 
   &e_frames[11], &e_frames[0]
};
TFrame* const anim_patadaAerea[PATADAAEREA_FRAMES] = { 
   &g_frames[13], &g_frames[0]
};
TFrame* const anim_patadaAerea_enemigo[PATADAAEREA_FRAMES] = { 
   &e_frames[13], &e_frames[0]
};
TFrame* const anim_defensa_agachado[DEFENSA_AGACHADO_FRAMES] = { 
   &g_frames[7]
};
TFrame* const anim_defensa_agachado_enemigo[DEFENSA_AGACHADO_FRAMES] = { 
   &e_frames[7], &e_frames[6]
};
TFrame* const anim_punyetazo_agachado[PUNYETAZO_AGACHADO_FRAMES] = { 
   &g_frames[8], &g_frames[6]
};
TFrame* const anim_punyetazo_agachado_enemigo[PUNYETAZO_AGACHADO_FRAMES] = { 
   &e_frames[8], &e_frames[6]
};



// Control de salto
#define PASOS_SALTO  20
const CPCT_2BITARRAY(g_tablaSalto, PASOS_SALTO) = {
     CPCT_ENCODE2BITS(3, 3, 3, 3) 
   , CPCT_ENCODE2BITS(3, 3, 2, 2)
   , CPCT_ENCODE2BITS(2, 2, 2, 1)
   , CPCT_ENCODE2BITS(1, 1, 1, 1)
   , CPCT_ENCODE2BITS(1, 0, 0, 0)
};

//Tabla de transparencia para que el protagonista no tenga fondo negro
//cpctm_createTransparentMaskTable (nombreTabla, direccionMemoria (SOLO deben variar ultimos dos digitos para MAS velocidad), Modo0, Color(0=negro))
cpctm_createTransparentMaskTable (g_tablatrans, 0x0100, M0, 0);


// #MUSICA
extern void playmusic(); //la declaro para que busque la funcion externa en ensamblador

// #MUSICA 
//contador para que cuando llegue a 6 llame a musicPlay y la ponga a 0
void interrupcion() {
   static u8 ii;

   if (++ii == 6) {
      playmusic(); //funcion en ensamblador para salvar los registros alternativos y principales
     // cpct_scanKeyboard_if();
      ii = 0;
   }
}


void dibujarRotulo(){
	//Como el rotulo es demasiado grande, se dividira en dos al hacer el "make"
	//En el retropolis.h estan los dos sprites con sus medidas correspondientes
	
	//Dibujamos los rotulos, como la posicion de pantalla es constante (el rotulo no se movera en ningun momento durante el juego)
	//usamos la funcion cpctm_screenPtr en lugar de pvmem
	cpct_drawSprite (g_fjuego_0, 
		cpctm_screenPtr(CPCT_VMEM_START, 0, 0)
		, G_FJUEGO_0_W, G_FJUEGO_0_H);

	//El segundo sprite lo dibujamos a continuacion del primero, como el primero mide 40 de ancho, en la funcion
	//cpctm_screenPtr le indicamos posicion (40,0), o tambien podemos poner (G_FJUEGO_0_W,0), porque el ancho del primer sprite son 40
	cpct_drawSprite (g_fjuego_1, 
		cpctm_screenPtr(CPCT_VMEM_START, G_FJUEGO_0_W, 0)
		, G_FJUEGO_1_W, G_FJUEGO_1_H);

	cpct_drawSprite (g_fjuego_2, 
		cpctm_screenPtr(CPCT_VMEM_START, 0, G_FJUEGO_0_H)
		, G_FJUEGO_2_W, G_FJUEGO_2_H);

	cpct_drawSprite (g_fjuego_3, 
		cpctm_screenPtr(CPCT_VMEM_START, G_FJUEGO_0_W, G_FJUEGO_0_H)
		, G_FJUEGO_3_W, G_FJUEGO_3_H);

}




void dibujarMapa(){
	//Funcion de easytilemaps pag de ayuda
	//cpct_etm_drawTilemap2x4(ancho, alto, coordenadasOrigen, puntero)
	cpct_etm_drawTilemap2x4 (g_map1_W, g_map1_H, ORIGEN_MAPA, mapa);
}

void asignarFrame(TFrame **animacion) {
	
	if(prota.estado==ST_andando || prota.estado==ST_agachado || prota.estado==ST_patadaAerea || prota.estado==ST_defensa || prota.estado==ST_defensa_agachado){
		prota.frame = animacion[prota.nframe / ANIM_PAUSA];
	}

	if(prota.estado==ST_punyetazo || prota.estado==ST_patada || prota.estado==ST_punyetazo_agachado){//ST_punyetazo || ST_patada || ST_punyetazo_agachado
		if(prota.nframe>=5){
			prota.frame = animacion[prota.nframe / 25];
			if(prota.nframe==49){
				 do { cpct_scanKeyboard_f(); } while ( cpct_isKeyPressed(Key_Z) || cpct_isKeyPressed(Key_X) );
			}
		}
	}



   /*if(prota.nframe==1){
		cpct_drawStringM0("1", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==2){
		cpct_drawStringM0("2", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==3){
		cpct_drawStringM0("3", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==4){
		cpct_drawStringM0("4", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==5){
		cpct_drawStringM0("5", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==6){
		cpct_drawStringM0("6", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==7){
		cpct_drawStringM0("7", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==8){
		cpct_drawStringM0("8", CPCT_VMEM_START, 5, 7);
	}
	if(prota.nframe==0){
		cpct_drawStringM0("0", CPCT_VMEM_START, 5, 7);
	}*/
}

void asignarFrameEnemigo(TFrame **animacion){
	if(enemigo.estado==ST_andando){
		enemigo.frame = animacion[enemigo.nframe / ANIM_PAUSA];
	}
	if(enemigo.estado==ST_punyetazo || enemigo.estado==ST_patada || enemigo.estado==ST_defensa || enemigo.estado==ST_punyetazo_agachado || enemigo.estado==ST_agachado || enemigo.estado==ST_defensa_agachado){
					//cpct_drawStringM0("PUMM!", CPCT_VMEM_START, 5, 7);
					/*if(enemigo.nframe==1){
						cpct_drawStringM0("1", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==2){
						cpct_drawStringM0("2", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==3){
						cpct_drawStringM0("3", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==4){
						cpct_drawStringM0("4", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==5){
						cpct_drawStringM0("5", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==6){
						cpct_drawStringM0("6", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==7){
						cpct_drawStringM0("7", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==8){
						cpct_drawStringM0("8", CPCT_VMEM_START, 5, 7);
					}
					if(enemigo.nframe==0){
						cpct_drawStringM0("0", CPCT_VMEM_START, 5, 7);
					}*/
		if(enemigo.nframe>=5){
			
			enemigo.frame = animacion[enemigo.nframe / 25];
		}
	}

	/*if(enemigo.estado==ST_patada){
		if(enemigo.nframe>=5){
			enemigo.frame=animacion[enemigo.nframe/25];
		}
	}*/

	/*if(enemigo.nframe==1){
		cpct_drawStringM0("1", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==2){
		cpct_drawStringM0("2", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==3){
		cpct_drawStringM0("3", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==4){
		cpct_drawStringM0("4", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==5){
		cpct_drawStringM0("5", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==6){
		cpct_drawStringM0("6", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==7){
		cpct_drawStringM0("7", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==8){
		cpct_drawStringM0("8", CPCT_VMEM_START, 5, 7);
	}
	if(enemigo.nframe==0){
		cpct_drawStringM0("0", CPCT_VMEM_START, 5, 7);
	}*/
}


void girarFrame(){
	TFrame* f = prota.frame;
   if (f->mira != prota.mira) { //Si el prota esta mirando a un lado y sprite al otro
      cpct_hflipSpriteM0(G_HERO_00_W, G_HERO_00_H, f->sprite); //El sprite gira hacia donde mira el prota
      f->mira = prota.mira; //Se le establece en la variable
   }
}

void girarFrameEnemigo(){
	TFrame* f = enemigo.frame;

	if(prota.x<enemigo.x){
		enemigo.mira=M_izquierda;
		if(f->mira!= enemigo.mira){
			cpct_hflipSpriteM0(E_ENEMY_00_W, E_ENEMY_00_H, f->sprite);
			f->mira=enemigo.mira;
			//cpct_drawStringM0("izq", CPCT_VMEM_START, 5, 7);
		}
	}


	if(prota.x>enemigo.x){
		enemigo.mira=M_derecha;
		if(f->mira!=enemigo.mira){
			cpct_hflipSpriteM0(E_ENEMY_00_W, E_ENEMY_00_H, f->sprite);
			f->mira=enemigo.mira;
			//cpct_drawStringM0("der", CPCT_VMEM_START, 5, 7);
		}
	}
}

void seleccionarSprite(){

		switch(prota.estado) {
	      case ST_quieto:      { prota.frame = &g_frames[0];  break; }
	      case ST_andando:     { asignarFrame(anim_andar);    break; }
	      case ST_prepSalto:   { prota.frame = &g_frames[12]; break; }
	      case ST_saltando:    { prota.frame = &g_frames[12]; break; }
	      case ST_cayendo:     { prota.frame = &g_frames[12]; break; }
	      case ST_aterrizando: { prota.frame = &g_frames[12]; break; }
	      case ST_punyetazo:   { asignarFrame(anim_punyetazo);break; }
	      case ST_agachado:    { asignarFrame(anim_agachado); break; }
	      case ST_patada:      { asignarFrame(anim_patada);   break; }
	      case ST_defensa: 	   { asignarFrame(anim_defensa);  break; }
	      case ST_patadaAerea: { asignarFrame(anim_patadaAerea); break; }
	      case ST_defensa_agachado: { asignarFrame(anim_defensa_agachado);  break; }
	      case ST_punyetazo_agachado: { asignarFrame(anim_punyetazo_agachado);  break; }

	   }
		girarFrame();

		switch(enemigo.estado) {
	      case ST_quieto:      { enemigo.frame = &e_frames[0]; break; }
	      case ST_andando:     { asignarFrameEnemigo(anim_andar_enemigo); break; }
	      /*case ST_prepSalto:   { prota.frame = &g_frames[12]; break; }
	      case ST_saltando:    { prota.frame = &g_frames[12]; break; }
	      case ST_cayendo:     { prota.frame = &g_frames[12]; break; }
	      case ST_aterrizando: { prota.frame = &g_frames[12]; break; }*/
	      case ST_punyetazo:   { asignarFrameEnemigo(anim_punyetazo_enemigo);break; }
	      case ST_agachado:    { asignarFrameEnemigo(anim_agachado_enemigo); break; }
	      case ST_patada:      { asignarFrameEnemigo(anim_patada_enemigo);   break; }
	      case ST_defensa: 	   { asignarFrameEnemigo(anim_defensa_enemigo);  break; }
	      /*case ST_patadaAerea: { asignarFrame(anim_patadaAerea); break; }*/
	      case ST_defensa_agachado: { asignarFrameEnemigo(anim_defensa_agachado_enemigo);  break; }
	      case ST_punyetazo_agachado: { asignarFrameEnemigo(anim_punyetazo_agachado_enemigo);  break; }

	   }
		girarFrameEnemigo();
		
		
}

void dibujarProta(){
	//cpct_drawSpriteMaskedAlignedTable (sprite del prota, puntero a memoria de video, ancho sprite, alto sprite, tablaTransparencias);

	//Conseguir un puntero a la memoria de video, teniendo en cuenta que la memoria de video empieza en CPCT_WMEM_START, junto a la posicion xy del prota
	//Por lo que pvmem = POSICION DE PANTALLA
	u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, prota.x, prota.y); //Declarar variables SOLO al principio de la funcion
	cpct_drawSpriteMaskedAlignedTable (prota.frame->sprite, pvmem, G_HERO_00_W, G_HERO_00_H, g_tablatrans);

}

void dibujarEnemigo(){
	u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, enemigo.x, enemigo.y);

	cpct_drawSpriteMaskedAlignedTable (enemigo.frame->sprite, pvmem, E_ENEMY_00_W, E_ENEMY_00_H, g_tablatrans);
	//cpct_drawSprite(enemigo.frame->sprite, pvmem, E_ENEMY_00_W, E_ENEMY_00_H);

}

//Funciones para que cada vez que el personaje se mueva, no vaya dejando un rastro
void borrarProta(){
	//Declarar variables SOLO al principio de la funcion
	//u8 w = 4 + (prota.px & 1);
	//u8 h = 7 + (prota.px & 3 ? 1 : 0);
    cpct_etm_drawTileBox2x4 (prota.px/2, (prota.py - ORIGEN_MAPA_Y)/4, 4, 7, g_map1_W, ORIGEN_MAPA, mapa );
}

void borrarEnemigo(){
	//u8 w = 4 + (enemigo.px & 1);
	//u8 h = 7 + (enemigo.px & 3 ? 1 : 0);
    cpct_etm_drawTileBox2x4 (enemigo.px/2, (enemigo.py - ORIGEN_MAPA_Y)/4, 4, 7, g_map1_W, ORIGEN_MAPA, mapa );
}

u8* obtenerTilePtr(u8 x, u8 y) {
   return mapa + (y-ORIGEN_MAPA_Y)/4*g_map1_W + x/2;
}

void ajustarAlSuelo() {
   prota.y = (prota.y & 0b11111100)+1;
}

u8 sobreSuelo() {
	//SI el personaje esta sobre un tile de id 14 quiere decir que esta sobre el suelo!!
   u8* tileSuelo = obtenerTilePtr(prota.x+2, prota.y + ALTOPROTA+1);
   if (*tileSuelo == 14 || *(tileSuelo+G_HERO_00_W/2-3) == 14)
      return 1;

   return 0;
}

u8 colisionPersonajes(){
	if(prota.x<enemigo.x+ANCHOPROTA &&
   			prota.x+ANCHOPROTA>enemigo.x &&
   			prota.y<enemigo.y+ALTOPROTA &&
   			ALTOPROTA + prota.y>enemigo.y){
		    //cpct_drawStringM0("COLISION", CPCT_VMEM_START, 5, 7);
   			return 1;
   		}
   	return 0;
}

//Funcion para mover a la der el personaje
void moverDerecha(){
	if(prota.x<LIMITE_DERECHO){
		if(colisionPersonajes()==0){
			prota.x++;
			prota.mover= SI;
			prota.mira  = M_derecha;
		}else if(prota.x>enemigo.x){ //Si hay colision pero esta a la der. del enemigo, le permite moverse
			prota.x++;
			prota.mover= SI;
			prota.mira=M_derecha;
		}
	}
}

//Funcion para mover a la izq el personaje
void moverIzquierda(){
	if(prota.x>0){
		if(colisionPersonajes()==0){
 			prota.x--;
			prota.mover= SI;
			prota.mira=M_izquierda;
		}else if(prota.x<enemigo.x){ //Si hay colision pero esta a la izq. del enemigo, le permite moverse
			prota.x--;
			prota.mover= SI;
			prota.mira=M_izquierda;
		}
	}
}

//Funcion para mover a la der el personaje
void moverDerechaEnemigo(){
	if(enemigo.x<LIMITE_DERECHO){
		if(colisionPersonajes()==0 && enemigo.x<LIMITE_DERECHO-ANCHOPROTA){
			if(enemigo.nframeRetraso++>1){
				enemigo.x++;
				enemigo.mover= SI;
				enemigo.nframeRetraso=0;
				girarFrameEnemigo();
			}
		}else{
			enemigo.estado=ST_quieto;
		}
	}
}

//Funcion para mover a la izq el personaje
void moverIzquierdaEnemigo(){
	if(enemigo.x>0){
		if(colisionPersonajes()==0 && enemigo.x>ANCHOPROTA){
			if(enemigo.nframeRetraso++>1){
				enemigo.x--;
				enemigo.mover= SI;
				enemigo.nframeRetraso=0;
				girarFrameEnemigo();
			}
		}else{
			enemigo.estado=ST_quieto;
		}
	}
}


void redibujarProta(){
	//Se borra al personaje en la posicion donde se encontraba
	borrarProta();

	//IMPORTANTE La posicion previa, ahora es la nueva
	prota.px= prota.x;
	prota.py= prota.y;
	//Se dibuja en la nueva posicion

	dibujarProta();
}

void redibujarEnemigo(){
	//Se borra al personaje en la posicion donde se encontraba
	borrarEnemigo();

	//IMPORTANTE La posicion previa, ahora es la nueva
	enemigo.px= enemigo.x;
	enemigo.py= enemigo.y;
	//Se dibuja en la nueva posicion
	
	dibujarEnemigo();
}


u8 compruebaTeclas(const cpct_keyID* k, u8 numk) {
   u8 i;
   cpct_scanKeyboard_if();
   if (cpct_isAnyKeyPressed()) {
      for(i=1; i <= numk; i++, k++) {
         if (cpct_isKeyPressed(*k))
            return i;
      }
   }
   return 0;
}

void quieto_entrar();

void aterrizando_entrar() {
   prota.nframe = 0;
   prota.estado = ST_aterrizando;
   prota.mover  = SI;
}

void aterrizando() {
   prota.mover = SI;
   if(++prota.nframe == SALTAR_FRAMES*ANIM_PAUSA)
      quieto_entrar();      
}


void cayendo_entrar() {
   prota.estado = ST_cayendo;
   prota.mover  = SI;
   prota.salto  = PASOS_SALTO - 3;
}

void descender() {
   prota.y += cpct_get2Bits(g_tablaSalto, prota.salto);
   if (prota.salto > 1)
      prota.salto--;
}

void patadaAerea_entrar();

void cayendo() {
   static const cpct_keyID keys[3] = {Key_X, Key_CursorRight, Key_CursorLeft};
   u8 k = compruebaTeclas(keys, 3);
   switch(k) {
      case 0: break; // Nada que hacer
      case 1: patadaAerea_entrar(); break;
      case 2: moverDerecha();   break;
      case 3: moverIzquierda(); break;
   }
   descender();
   if (sobreSuelo()) {
      ajustarAlSuelo();
      aterrizando_entrar();
   }
   prota.mover=SI;


}

void quieto_entrar();


void quieto_entrar() {
   prota.estado = ST_quieto;
   prota.mover  = SI;
}


void andando_entrar(u8 mirar);
void patada_entrar();
void punyetazo_entrar();
void agachado_entrar();
void defensa_entrar();
void prepSalto_entrar();

void quieto() {
   static const cpct_keyID keys[7] = {Key_CursorUp, Key_CursorDown, Key_Z, Key_X, Key_C, Key_CursorRight, Key_CursorLeft};
   u8 k = compruebaTeclas(keys, 7);
   switch(k) {
      case 0: break; // Nada que hacer
      case 1: prepSalto_entrar(); break;
      case 2: agachado_entrar(); break;
      case 3: punyetazo_entrar(); break;
      case 4: patada_entrar(); break;
      case 5: defensa_entrar(); break;
      case 6: andando_entrar(M_derecha);   break;
      case 7: andando_entrar(M_izquierda); break;
   }

}

void quietoEnemigo(){
	enemigo.nframe=0;
	//enemigo.estado=ST_quieto;
	enemigo.mover=SI;
	/*cpct_waitVSYNC();
	redibujarEnemigo();

	if(enemigo.nframe==0){
		cpct_drawStringM0("0", CPCT_VMEM_START, 5, 7);
	}*/
}

void ascender() {
   prota.y -= cpct_get2Bits(g_tablaSalto, prota.salto);
   if (prota.y < ORIGEN_MAPA_Y)
      prota.y = ORIGEN_MAPA_Y;
   if (++prota.salto == PASOS_SALTO)
      cayendo_entrar();
}


void agachado_entrar(){
   prota.nframe = 0;
   prota.estado = ST_agachado;
   prota.mover  = SI;
}

void saltando_entrar() {
   prota.estado = ST_saltando;
   prota.mover  = SI;
   prota.salto  = 0;
}

void defensa_entrar(){
   prota.nframe = 0;
   prota.estado = ST_defensa;
   prota.mover  = SI;
}



void saltando() {
   if (!cpct_isKeyPressed(Key_CursorUp)) {
      cayendo_entrar();
   } else {
      static const cpct_keyID keys[2] = {Key_CursorRight, Key_CursorLeft};
      u8 k = compruebaTeclas(keys, 2);
      switch(k) {
         case 0: break;
         //case 1: patadaAerea_entrar(); break;
         case 1: moverDerecha();   break;
         case 2: moverIzquierda(); break;
         
      }
      ascender();
      prota.mover = SI;
   }
}

void patadaAerea_entrar(){
   prota.nframe = 0;
   prota.estado = ST_patadaAerea;
   prota.mover  = SI;
}

void patadaAerea_animar(){
   if(++prota.nframe == PATADAAEREA_FRAMES*ANIM_PAUSA)
      prota.nframe = 0;
}

void patadaAerea(){
   static const cpct_keyID keys[1] = {Key_X};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: quieto_entrar();    break;
      case 1: patadaAerea_animar(); break;
   }
   prota.estado=ST_cayendo;
}

void prepSalto_entrar() {
   prota.nframe = 0;
   prota.estado = ST_prepSalto;
   prota.mover  = SI;
}

void prepSalto_animar() {
   if (++prota.nframe == SALTAR_FRAMES*ANIM_PAUSA)
      saltando_entrar(); 
}

void prepSalto() {
   static const cpct_keyID keys[1] = {Key_CursorUp};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: quieto_entrar(); break; 
      case 1: prepSalto_animar(); break;
   }
   prota.mover = SI;
}


void andando_entrar(u8 mirar) {
   prota.nframe = 0;
   prota.estado = ST_andando;
   prota.mira   = mirar;
   prota.mover  = SI;
}

void andando_animar(u8 mirar) {
   prota.mira  = mirar;
   if(++prota.nframe == ANDAR_FRAMES*ANIM_PAUSA)
      prota.nframe = 0;
}

void andando_animar_enemigo(u8 mirar) {
   enemigo.mira  = mirar;

   if(++enemigo.nframe == ANDAR_FRAMES*ANIM_PAUSA)
      enemigo.nframe = 0;
}

void andando() {
   static const cpct_keyID keys[7] = {Key_CursorUp, Key_CursorDown, Key_Z, Key_X, Key_C, Key_CursorRight, Key_CursorLeft};
   u8 k = compruebaTeclas(keys, 7);
   switch(k) {
      case 0: quieto_entrar();    break;
      case 1: prepSalto_entrar(); break;
      case 2: agachado_entrar(); break;
      case 3: punyetazo_entrar(); break;
      case 4: patada_entrar(); break;
      case 5: defensa_entrar(); break;
      case 6: 
	      moverDerecha();   
	      andando_animar(M_derecha);   
	      break;
      case 7: 
	      moverIzquierda(); 
	      andando_animar(M_izquierda); 
	      break;
   }
   prota.mover = SI;
   if (!sobreSuelo())
      cayendo_entrar();
}

void andandoEnemigo(){
	if(enemigo.mira==M_izquierda){
		moverIzquierdaEnemigo();
		andando_animar_enemigo(M_izquierda);
	}

	if(enemigo.mira==M_derecha){
		moverDerechaEnemigo();
		andando_animar_enemigo(M_derecha);
	}
}


void patada_entrar(){
   prota.nframe = 0;
   prota.estado = ST_patada;
   prota.mover  = SI;
}

void patada_animar(){
	if(++prota.nframe == PATADA_FRAMES*25)
      prota.nframe = 0;
}

void patada(){
   static const cpct_keyID keys[1] = {Key_X};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: quieto_entrar(); break;
      case 1: patada_animar(); break;
   }
   prota.mover=SI;
}

void patada_animar_enemigo(){
	if(++enemigo.nframe == PATADA_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void patadaEnemigo(){
	patada_animar_enemigo();
	enemigo.mover=SI;
}

void punyetazo_entrar(){
   prota.nframe = 0;
   prota.estado = ST_punyetazo;
   prota.mover  = SI;
}


void punyetazo_animar(){
	if(++prota.nframe == PUNYETAZO_FRAMES*25){
		prota.nframe = 0;
	}
}

void punyetazo(){
	//cpct_drawStringM0("hola", CPCT_VMEM_START, 5, 7);
   static const cpct_keyID keys[1] = {Key_Z};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: quieto_entrar();    break;
      case 1: punyetazo_animar(); break;
   }
   prota.mover=SI;
}

void punyetazo_animar_enemigo(){
	if(++enemigo.nframe == PUNYETAZO_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void punyetazoEnemigo(){
	punyetazo_animar_enemigo();
	enemigo.mover=SI;
}

void defensa_animar(){
	if(++prota.nframe == DEFENSA_FRAMES*ANIM_PAUSA)
      prota.nframe = 0;
}

void defensa(){
   static const cpct_keyID keys[1] = {Key_C};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: quieto_entrar();    break;
      case 1: defensa_animar(); break;
   }
}


void defensa_animar_enemigo(){
	if(++enemigo.nframe == DEFENSA_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void defensaEnemigo(){
	defensa_animar_enemigo();
	enemigo.mover=SI;
}


void agachado_animar(){
	if(++prota.nframe == AGACHAR_FRAMES*ANIM_PAUSA)
      prota.nframe = 0;
}

void defensa_agachado_entrar();
void punyetazo_agachado_entrar();

void agachado(){
	//cpct_drawStringM0("hola", CPCT_VMEM_START, 5, 7);
   static const cpct_keyID keys[3] = {Key_C, Key_Z, Key_CursorDown};
   u8 k = compruebaTeclas(keys, 3);
   switch(k) {
      case 0: quieto_entrar();    break;
      case 1: defensa_agachado_entrar(); break;
      case 2: punyetazo_agachado_entrar(); break;
      case 3: agachado_animar(); break; 
   }
}

void agachado_animar_enemigo(){
	if(++enemigo.nframe == AGACHAR_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void agachadoEnemigo(){
	agachado_animar_enemigo();
	enemigo.mover=SI;
}


void defensa_agachado_entrar(){
	prota.nframe = 0;
    prota.estado = ST_defensa_agachado;
    prota.mover  = SI;
}

void defensa_agachado_animar(){
	if(++prota.nframe == DEFENSA_AGACHADO_FRAMES*ANIM_PAUSA)
      prota.nframe = 0;
}

void punyetazo_agachado_entrar(){
	prota.nframe = 0;
    prota.estado = ST_punyetazo_agachado;
    prota.mover  = SI;
}

void punyetazo_agachado_animar(){
	if(++prota.nframe == PUNYETAZO_AGACHADO_FRAMES*25)
      prota.nframe = 0;
}

void punyetazoAgachado(){
	static const cpct_keyID keys[1] = {Key_Z};
   u8 k = compruebaTeclas(keys, 1);
   switch(k) {
      case 0: agachado_entrar();   break;
      case 1: punyetazo_agachado_animar(); break;
   }
    prota.mover=SI;
}


void punyetazoAgachado_animar_enemigo(){
	if(++enemigo.nframe == PUNYETAZO_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void punyetazoAgachadoEnemigo(){
	punyetazoAgachado_animar_enemigo();
	enemigo.mover=SI;
}


void defensaAgachado(){
	static const cpct_keyID keys[2] = {Key_C, Key_CursorDown};
   u8 k = compruebaTeclas(keys, 2);
   switch(k) {
      case 0: quieto_entrar();   break;
      case 1: defensa_agachado_animar(); break;
      case 2: agachado_entrar(); break;
   }
}

void defensaAgachado_animar_enemigo(){
	if(++enemigo.nframe == DEFENSA_AGACHADO_FRAMES*25){
		enemigo.nframe = 0;
	}
}

void defensaAgachadoEnemigo(){
	defensaAgachado_animar_enemigo();
	enemigo.mover=SI;
}


void ejecutarEstado() {
   switch(prota.estado) {
      case ST_quieto:      quieto();      break;
      case ST_andando:     andando();     break;
      case ST_prepSalto:   prepSalto();   break;
      case ST_saltando:    saltando();    break;
      case ST_cayendo:     cayendo();     break;
      case ST_aterrizando: aterrizando(); break;
      case ST_agachado:    agachado();    break;
      case ST_punyetazo:   punyetazo();   break;
      case ST_patada:      patada();	  break;
      case ST_defensa:     defensa();	  break;
      case ST_patadaAerea: patadaAerea(); break;
      case ST_defensa_agachado: defensaAgachado(); break;
      case ST_punyetazo_agachado: punyetazoAgachado(); break;
   }
}

void ejecutarEstadoEnemigo() {
   switch(enemigo.estado) {
      case ST_quieto:      quietoEnemigo();      break;
      case ST_andando:     andandoEnemigo();     break;
      /*case ST_prepSalto:   prepSalto();   break;
      case ST_saltando:    saltando();    break;
      case ST_cayendo:     cayendo();     break;
      case ST_aterrizando: aterrizando(); break;*/
      case ST_agachado:    agachadoEnemigo();    break;
      case ST_punyetazo:   punyetazoEnemigo();    break;
      case ST_patada:      patadaEnemigo();	  break;
      case ST_defensa:     defensaEnemigo();	  break;
      /*case ST_patadaAerea: patadaAerea(); break;*/
      case ST_defensa_agachado: defensaAgachadoEnemigo(); break;
      case ST_punyetazo_agachado: punyetazoAgachadoEnemigo(); break;
   }
}

void actualizarVida(){
   // u8 str[10];
   // u8 str2[10];
   int i;
   float p,p2;
   //sprintf(str, "%d", prota.vida);
   //sprintf(str2, "%d", enemigo.vida);
   
   p = prota.vida/5;
   p2 = enemigo.vida/5;
   if(prota.vida % 5 != 0){
      p++;
   }
   if(enemigo.vida % 5 != 0){
      p2++;
   }
   // dibujarRotulo();
   // cpct_drawStringM0("   ", CPCT_VMEM_START, 5, 7);
   // cpct_drawStringM0(str, CPCT_VMEM_START, 5, 7);
   // cpct_drawStringM0("   ", 0xC050, 7, 5);
   // cpct_drawStringM0(str2, 0xC050, 7, 5);
   // dibujarRotulo();
   // cpct_drawSprite(g_vida,cpctm_screenPtr(CPCT_VMEM_START, 0, 0),G_VIDA_W,G_VIDA_H);

   cpct_drawSprite(g_fondo,cpctm_screenPtr(CPCT_VMEM_START, 5, 2),G_FONDO_W,G_FONDO_H);
   cpct_drawSprite(g_fondo,cpctm_screenPtr(CPCT_VMEM_START, 55, 2),G_FONDO_W,G_FONDO_H);

   for (i=0; i < p; ++i)
   {
      cpct_drawSprite(g_vida,cpctm_screenPtr(CPCT_VMEM_START, 5+G_VIDA_W*i, 2),G_VIDA_W,G_VIDA_H);
   }

   for (i=0; i < p2; ++i)
   {
      cpct_drawSprite(g_vida,cpctm_screenPtr(CPCT_VMEM_START, 54+G_VIDA_W*(20-i), 2),G_VIDA_W,G_VIDA_H);
   }
}

void calcularDanyo(){
	/***ENEMIGO ATACA***/
	if(colisionPersonajes()==1){
		if((enemigo.estado==ST_punyetazo || enemigo.estado==ST_patada) && 
			(prota.estado!=ST_agachado || prota.estado!=ST_punyetazo_agachado || prota.estado!=ST_defensa_agachado)){
			if(enemigo.nframe==15){
				if(prota.estado==ST_defensa){
					prota.vida--;
				}else{
					prota.vida=prota.vida-10;
				}
				actualizarVida();
			}
		}

		if(enemigo.estado==ST_punyetazo_agachado){
			if(enemigo.nframe==15){
				if(prota.estado==ST_defensa_agachado){
					prota.vida--;
				}else{
					prota.vida=prota.vida-10;
				}
				actualizarVida();
			}
		}

		/***JUGADOR ATACA***/
		if((prota.estado==ST_punyetazo || prota.estado==ST_patada) && 
			(enemigo.estado!=ST_agachado || enemigo.estado!=ST_punyetazo_agachado || enemigo.estado!=ST_defensa_agachado)){
			if(prota.nframe==10){
				if(enemigo.estado==ST_defensa){
					enemigo.vida--;
				}else{
					enemigo.vida=enemigo.vida-10;
				}
				actualizarVida();
			}
		}

		if(prota.estado==ST_punyetazo_agachado){
			if(prota.nframe==10){
				if(enemigo.estado==ST_defensa_agachado){
					enemigo.vida--;
				}else{
					enemigo.vida=enemigo.vida-10;
				}
				actualizarVida();
			}
		}

		if(prota.estado==ST_patadaAerea && enemigo.estado!=ST_agachado){
				//La patada aerea hace mas danyo
				if(enemigo.estado==ST_defensa){
					enemigo.vida=enemigo.vida-2; 
				}else{
					enemigo.vida=enemigo.vida-15;
				}
				actualizarVida();
		}
	}
}



void saltoEncimaResbalar(){
	if(prota.estado==3 || prota.estado==4){
		if(colisionPersonajes()==1){
			if(prota.x<enemigo.x){
				prota.x--;
			}else{
				prota.x++;
			}
		}
	}
}

//Funcion que se ejecutara nada mas iniciar el juego
void inicializar(){
	// u8 str[10];   // string to write the value on

	//Algo que se ejecuta en 2º plano, no lo usamos por tanto lo desactivamos para acelerar el proceso
	cpct_disableFirmware();
	cpct_setVideoMode(0); //Modo de la pantalla a 0
	cpct_setBorder(HW_BLACK); //Color de borde
	cpct_setPalette(g_palette, 16); //Array paleta de colores
	// #MUSICA FUNCIONAR
    //cpct_akp_musicInit(G_cancion); 
    //cpct_setInterruptHandler(interrupcion); //cada vez q hay una interrupcion ejecuta el metodo interrupcion()
    

	mapa= g_map1;
	cpct_etm_setTileset2x4(g_tileset); //Que conjunto de tiles voy a utilizar (linea 6 de tiles.h)
	dibujarMapa(); //... y dibujamos el mapa

	//Invocamos la funcion para dibujar el rotulo
	dibujarRotulo();

	//Posicion inicial del protagonista (20,155)
	prota.x= prota.px= 20;
	prota.y= prota.py= 152;
	prota.estado= ST_quieto;
	prota.mira=M_derecha;
	girarFrame();
	prota.nframe=0;
	prota.mover= NO; //El personaje esta quieto al inicio
	prota.vida=VIDA;
	//prota.sprite= g_hero_00; //variable definida en hero.h, se trata del primer sprite de la imagen de sprites del heroe
	prota.frame = &g_frames[0]; //Primera posicion del array g_frames, se pone el sprite mirando a la derecha, y se coge el primer sprite del spritesheet del heroe
	
	//Posicion inicial del enemigo (60, 155)
	enemigo.x= enemigo.px= 60;
	enemigo.y= enemigo.py= 152;
	enemigo.estado= ST_quieto;
	enemigo.mira= M_izquierda;
	girarFrameEnemigo();
	enemigo.nframe=0;
	enemigo.mover=NO;
	enemigo.vida=VIDA;
	enemigo.frame= &e_frames[0];

	dibujarProta(); //Se dibuja al protagonista
	dibujarEnemigo(); //Se dibuja al enemigo

	// sprintf(str, "%d", prota.vida);
   //cpct_drawStringM0(str, CPCT_VMEM_START, 5, 7);
   actualizarVida();
   // sprintf(str, "%d", enemigo.vida);
   //cpct_drawStringM0(str, 0xC050, 7, 5);
	cpct_srand(getSeed());
	
}


u8 abs(i8 x1){
	u8 result;
	if(x1<0){
		result=-x1;
	}else{
		result=x1;
	}
	return result;
}

void main(void) {
   menu();
   inicializar();
    

   // Loop forever
   while (1){
		
   		
   		if(enemigo.nframe==49){ //De los 50 frames de animacion del enemigo, 25 son de ataque
   		// NUMERO MAS BAJO = MAYOR CAPACIDAD DE REACCION DEL ENEMIGO = DIFICULTAD++??
   			random_number = cpct_rand(); 
   		}
   		//comprobarTeclado();
   		ejecutarEstado();

   		/****IA****/
   		ejecutarEstadoEnemigo();
   		seleccionarSprite();

   		if(enemigo.estado==ST_quieto || enemigo.estado==ST_punyetazo || enemigo.estado==ST_patada || enemigo.estado==ST_defensa || enemigo.estado==ST_punyetazo_agachado || enemigo.estado==ST_agachado || enemigo.estado==ST_defensa_agachado){
   			if(abs(enemigo.x-prota.x)>=ANCHOPROTA && prota.estado!=ST_saltando && prota.estado!=ST_cayendo && prota.estado!=ST_patadaAerea){ //DISTANCIA - El enemigo se acerca al jugador si este no se encuentra cerca
				enemigo.estado=ST_andando;
				enemigo.mover=SI;
				enemigo.nframe=0;
				

			}else{ //Si se encuentra cerca, esta listo para realizar otras acciones
				
				/**ATAQUE**/
				if(prota.estado==ST_defensa_agachado || prota.estado==ST_agachado || prota.estado==ST_punyetazo_agachado){ //Si esta agachado, defendiendose o atacando, el enemigo decidira atacar por debajo SIEMPRE
					enemigo.estado=ST_punyetazo_agachado;
				}else{
					if(random_number<100){ //Si el numero random es menor que 100, pega punyetazo
						enemigo.estado=ST_punyetazo;
					}else if(random_number>=100 && random_number<200){ //Si es entre 100-200, patada
						enemigo.estado=ST_patada;
					}else if(random_number>=200){ //Si es mayor que 200, punyetazo agachado
						enemigo.estado=ST_punyetazo_agachado;
					}

					if(prota.estado==ST_defensa){
						if(random_number>=100){ //Si el jugador se defiende de pie, aumentan las posibilidades de que el enemigo decida atacar agachado
							enemigo.estado=ST_punyetazo_agachado;
						}
					}
				}

				/**DEFENSA**/
				if(prota.estado==ST_punyetazo_agachado){ //Si el jugador ataca por debajo, el enemigo A VECES se defendera agachado
					if(random_number%2==0){ //Cuando el numero random sea par, se defendera
						enemigo.estado=ST_defensa_agachado;
					}
				}else{
					if(prota.estado==ST_punyetazo || prota.estado==ST_patada){
						if(random_number>=100){ //Si el jugador ataca al enemigo y el numero random es mayor o igual que 100, el enemigo se defendera
							enemigo.estado=ST_defensa;
						}
					}

					if(prota.estado==ST_patadaAerea || prota.estado==ST_saltando || prota.estado==ST_cayendo){
						//Si el jugador esta en el aire, el enemigo se defendera, agachara, o no hara nada (este ultimo con escasa probabilidad)
						if(random_number<=150){
							enemigo.estado=ST_defensa;
						}else if(random_number>150 && random_number<=250){
							enemigo.estado=ST_agachado;
						}
					}
				}




				enemigo.mover=SI;
			}
   		}


		saltoEncimaResbalar();  //Si el prota salta por encima del enemigo y va a caer sobre el, se resbala hacia los lados para no quedar encima

		


		cpct_waitVSYNC(); //DESPUES de sincronizar UNICA Y EXCLUSIVAMENTE DIBUJAR!!! CERO calculos... si sigue habiendo problemas, se puede usar doble buffer

   		if(prota.mover){ //SOLO se dibujara el personaje cuando prota.mover=SI
   			//cpct_drawStringM0("hola", CPCT_VMEM_START, 5, 7);
   			redibujarProta();
   			
   			
   			prota.mover=NO;
   		}	

   		if(enemigo.mover==SI || prota.estado==ST_saltando || prota.estado==ST_aterrizando || prota.estado==ST_cayendo){
			redibujarEnemigo();

			enemigo.mover=NO;
		}

	if(prota.vida<=0 || prota.vida>100){
      ganador(0);
		inicializar();
	}

	if(enemigo.vida<=0 || enemigo.vida>100){
      ganador(1);
		inicializar();
	}
	
	calcularDanyo();
	

	
	

   }
}
